VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00A56E3A&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "VB Helper UK (Sample App), EnumPrinters & EnumJobs (API)"
   ClientHeight    =   5850
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8130
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5850
   ScaleWidth      =   8130
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrGetJobs 
      Interval        =   1000
      Left            =   6630
      Top             =   5310
   End
   Begin VB.Frame fraPrintJobs 
      BackColor       =   &H00A56E3A&
      Caption         =   "No printer selected"
      ForeColor       =   &H00FFFFFF&
      Height          =   4920
      Left            =   3210
      TabIndex        =   6
      Top             =   135
      Width           =   4800
      Begin VB.ListBox lstPrintJobs 
         Appearance      =   0  'Flat
         BackColor       =   &H00A56E3A&
         ForeColor       =   &H00FFFFFF&
         Height          =   4515
         Left            =   105
         TabIndex        =   7
         Top             =   270
         Width           =   4590
      End
   End
   Begin VB.Frame fraPrinters 
      BackColor       =   &H00A56E3A&
      Caption         =   "Printers"
      ForeColor       =   &H00FFFFFF&
      Height          =   4920
      Left            =   105
      TabIndex        =   2
      Top             =   135
      Width           =   3015
      Begin VB.OptionButton PrinterType 
         BackColor       =   &H00A56E3A&
         Caption         =   "Remote Printers"
         ForeColor       =   &H00FFFFFF&
         Height          =   210
         Index           =   1
         Left            =   135
         TabIndex        =   5
         Top             =   510
         Width           =   1470
      End
      Begin VB.OptionButton PrinterType 
         BackColor       =   &H00A56E3A&
         Caption         =   "Local Printers"
         ForeColor       =   &H00FFFFFF&
         Height          =   210
         Index           =   0
         Left            =   135
         TabIndex        =   4
         Top             =   270
         Value           =   -1  'True
         Width           =   1305
      End
      Begin VB.ListBox lstPrinters 
         Appearance      =   0  'Flat
         BackColor       =   &H00A56E3A&
         ForeColor       =   &H00FFFFFF&
         Height          =   3540
         Left            =   105
         TabIndex        =   3
         Top             =   840
         Width           =   2790
      End
   End
   Begin VB.CommandButton cmdExit 
      BackColor       =   &H00D8EBEB&
      Caption         =   "E&xit"
      Height          =   420
      Left            =   4080
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   5310
      Width           =   1980
   End
   Begin VB.CommandButton cmdRefresh 
      BackColor       =   &H00D8EBEB&
      Caption         =   "Refresh Lists"
      Height          =   420
      Left            =   2070
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   5310
      Width           =   1980
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'######################################################################
'                    This example was written by Grant French of VB Helper UK
'                         Contact Info: E-Mail: grant.french@libertysurf.co.uk
'                                                 ICQ: 33122184
'######################################################################

Private Sub cmdExit_Click()
      End
End Sub

Private Sub cmdRefresh_Click()

'Clear the list of printers
lstPrinters.Clear

'Check whether the user wants a list of local (0) or remote (1) printers
If PrinterType(0).Value = True Then
      
      'Set the selected printer to "" (See the tmrGetJobs code)
      frmMain.Tag = ""
      
      'Get a list of local printers
      GetPrinters lstPrinters, False
      
Else
      
      'Set the selected printer to ""  (See the tmrGetJobs code)
      frmMain.Tag = ""
      
      'Get a list of remote printers
      GetPrinters lstPrinters, True
End If

'Set the selected printer to ""  (See the tmrGetJobs code)
frmMain.Tag = ""

'Tell the user that there is no printer selected
fraPrintJobs.Caption = "No printer selected"

'Clear the printjobs from lstPrintJobs
lstPrintJobs.Clear

End Sub

Private Sub Form_Load()

'Get a list of local printers
GetPrinters lstPrinters, False

End Sub

Private Sub Form_Terminate()
'######################################################################
'                    This example was written by Grant French of VB Helper UK
'                         Contact Info: E-Mail: grant.french@libertysurf.co.uk
'                                                 ICQ: 33122184
'######################################################################
'This project may not work under Windows NT/2000

msg = MsgBox("If you have any more queries, please contact me by:" & vbCrLf & vbCrLf & "E-Mail: grant.french@libertysurf.co.uk" & vbCrLf & "ICQ: 33122184", vbInformation, "Queries?")
End Sub

Private Sub lstPrinters_Click()

'Declare the required variables for this procedure
Dim SelectedPrinter As Long


If lstPrinters.SelCount > 0 Then

      'Tell the user which printer the print jobs are being shown
      fraPrintJobs.Caption = "Print jobs for " & lstPrinters
      
      'Clear the list of print jobs
      lstPrintJobs.Clear
      
      'Get the print jobs for the selected printer
      GetPrintJobs lstPrinters, lstPrintJobs
      
      'Allow the tmrGetJobs to know which printer is selected without scanning through
      ' all of the printers in the list itself.
      frmMain.Tag = lstPrinters
      
Else

      'If there is no printer selected then
      'Set the selected printer to ""  (See the tmrGetJobs code)
      frmMain.Tag = ""
      
      'Tell the user that there is no printer selected
      fraPrintJobs.Caption = "No printer selected"
      
      'Clear the printjobs from lstPrintJobs
      lstPrintJobs.Clear
      
End If
End Sub

Private Sub lstPrintJobs_Click()
'Show the user the details in an interpreatable form if they click on a job

'Define the variables required for this procedure
Dim JobDetails() As String

'If there is a selected job then
If lstPrintJobs.SelCount > 0 Then
      
      'Split the list item up into its original components (JobID, PrinterName, UserName, MachineName, DoucmentName, TotalPages, Time/Date Printed)
      JobDetails() = Split(lstPrintJobs, ";")
      
      'If the total number of components is not 7 then exit the sub routine (remember Base 0, 0 to 6 = 7)
      If UBound(JobDetails()) < 6 Then Exit Sub
      
      'Display the items to the user
      msg = MsgBox("Job ID:" & JobDetails(0) & vbCrLf & "Printername:" & JobDetails(1) & vbCrLf & "Printed by:" & JobDetails(2) & vbCrLf & "Printed on machine:" & JobDetails(3) & vbCrLf & "Document:" & JobDetails(4) & vbCrLf & "Number of pages:" & JobDetails(5) & vbCrLf & "Time/Date Printed:" & JobDetails(6), , "Print Job details")

End If
End Sub

Private Sub PrinterType_Click(Index As Integer)
'When the user changes to Local/Remote printers option

'Clear the list of printers
lstPrinters.Clear

'Check to see which one the user has selected
If PrinterType(0).Value = True Then
      
      'Set the selected printer to ""  (See the tmrGetJobs code)
      frmMain.Tag = ""
      
      'Get a list of local printers
      GetPrinters lstPrinters, False
      
Else
      
      'Set the selected printer to ""  (See the tmrGetJobs code)
      frmMain.Tag = ""
      
      'Get a list of remote printers
      GetPrinters lstPrinters, True
      
End If

End Sub

Private Sub tmrGetJobs_Timer()
      
      'Check to see if the user has selected a printer
      If frmMain.Tag <> "" Then
            
            'Clear the print jobs list
            lstPrintJobs.Clear
            
            'Get the info on the printjobs for the selected printer
            GetPrintJobs frmMain.Tag, lstPrintJobs
            
      End If

End Sub
